/* =====================================================================

   LiMo Reversi 
      Computer Thinking.  - ԥ塼롼

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Dec.05.1999  Programing start
  Aug.14.1999  fork б

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RVComStart         -- ԥ塼λ׹ͥ
  RVComStat          -- ͤ椫ݤ
  RVComGet           -- ǤľϤ

  RVComReturn        -- ׹ͥ롼󤫤η̼

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <gtk/gtk.h>
#include <gdk/gdkprivate.h>
#include "rr_switch.h"
#include "rv_board.h"

/* --- ԥ塼¦׹ͥ롼 */
#include "ai_think001.h"
#include "ai_think002.h"
#include "ai_think003.h"

/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* ---- DEBUG  define ˤ process fork ޤ */
#undef    AI_DEBUG

/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

gboolean  think_flag;
gint      com_pos;

int       return_pipe;

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RVComStart         -- ԥ塼λ׹ͥ

   return : void
   gint level (׹ͥ롼ֹ)

-------------------------------------------------------------- */
void  RVComStart(gint level)
{
#ifndef AI_DEBUG
  pid_t  pid;
  time_t  t;
  int  ai_sock[2], ai, i;

  /* --- ̿ѥåȤκ */
  if (socketpair(AF_UNIX, SOCK_STREAM, PF_UNSPEC, ai_sock) < 0) {
    perror("ERROR sound: socketpair can't make.\n");
    return;
  }
  return_pipe = 0;

  /* --- ץե */
  pid = fork();
  if (pid < 0) {
    perror("ai fork.\n");
    close(ai_sock[0]);
    close(ai_sock[1]);
    think_flag = FALSE;
    com_pos = -1;
    return;
  }
  else if (pid) {
    /* -- ƥץȽ */
    close(ai_sock[1]);
    return_pipe = ai_sock[0];
    think_flag = TRUE;
    com_pos = -1;
    return;
  }

  /* --- ҥץȽ */
  close(ai_sock[0]);
  return_pipe = ai_sock[1];
#endif


  /* --- ٥ˤäƻ׹ͥ롼Ф餱ޤ */
  ai = 0;
  if (RRSwitchGetLevel() > 0) {
    ai = RRSwitchGetLevel();
    if (ai > 2) {
      ai = 2;
    }
  }
  else {
    t = time(NULL);
    i = ((gint)t) % 100;
    if (i < level) {
      ai = 2;
    }
    else {
      ai = (i % 2);
    }
  }
  

  /* --- ׹ͥ롼ʬǤ */
  switch(ai) {
  case 0 :
    ai_think001();
    break;
  case 1:
    ai_think002();
    break;
  case 2:
    ai_think003();
    break;
  }

#ifdef AI_DEBUG
  think_flag = FALSE;
#else
  close(return_pipe);
  /* ==  X ؤΥѥפեå夷ʤȸư褦 */
  /*       ʤǤ狼ʤ  (Aug.19.2000)      */
  /*                                        Rero2@fumi      */
  XFlush(NULL);
  exit;
#endif
}


/* -------------------------------------------------------------
  RVComStat          -- ͤ椫ݤ

   return : gboolean (TRUE=ޤ׹)
   void

-------------------------------------------------------------- */
gboolean  RVComStat(void)
{
#ifdef AI_DEBUG
  /* --- ǥХå⡼ɤǤʤФä꽪λ */
  return(think_flag);
#else
  /* --- ̾⡼ɤ select ǽλԤ */
  fd_set  readfd;
  struct timeval tv;
  unsigned char fromsock=0;
  int  wait_input;

  /* --  */
  if (return_pipe == 0) {
    return(FALSE);
  }

  /* -- ѥ׼Ԥ */
  tv.tv_sec = 0;
  tv.tv_usec = 0;
  FD_ZERO(&readfd);
  FD_SET(return_pipe, &readfd);
  wait_input = select(return_pipe+1, &readfd, NULL, NULL, &tv);
  /* -------------------------------------------------*/
  /* ----- Ϥäʤꡢλ             */
  /* -------------------------------------------------*/
  if ((wait_input > 0) && (FD_ISSET(return_pipe, &readfd) != 0)) {
    read(return_pipe, &fromsock, 1);
    com_pos = (gint)(fromsock) - 1;
    think_flag = FALSE;
    close(return_pipe);
    wait(NULL);
    return_pipe = 0;
  }
  return(think_flag);
#endif
}


/* -------------------------------------------------------------
  RVComGet           -- ǤľϤ

   return : gint (Ǥľ 063)
   void

-------------------------------------------------------------- */
gint  RVComGet(void)
{
  return(com_pos);
}


/* -------------------------------------------------------------
  RVComReturn        -- ׹ͥ롼󤫤η̼

   return : void
   gint hit (Ǥľ 063)

-------------------------------------------------------------- */
void  RVComReturn(gint hit)
{
#ifdef AI_DEBUG
  com_pos = hit;
#else
  /* --- ̾⡼ɤ pipe ͳϤ */
  unsigned char  r;

  r = (unsigned char)(hit + 1);
  write(return_pipe, &r, 1);
#endif
}


/* -----------------------------------------------------------------------

 --- ׹ͥ롼μ֤ ai_think* եˤ

------------------------------------------------------------------------ */

