/* =====================================================================

   LiMo Reversi 
      Graphic Data Manage.  - ޤѤǡδ

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Nov.23.1999  Programing start

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RVDataInit       -- ǡץɤ߹
  RVDataIndex      -- ǡǥåΥ
  RVDataFree       -- ǡ
  RVDataSoundRequest    -- ɥޥ͡㡼ؤΥꥯ
  RVDataKoma       -- ǡμϤ
  RVDataGrid       -- ܥǡμϤ
  RVDataComLevel   -- ơΥԥ塼ζ
  RVDataTitle      -- ȥ̤Ϥ
  RVDataTitleParts    -- ȥ̤Ϥ
  RVDataCircle     -- Ϥ
  RVDataCircleBack -- ХåϤ
  RVDataContinueBack  -- ƥ˥塼̥ХåϤ
  RVDataContinueParts -- ƥ˥塼̥ѡĤϤ
  RVDataGameover      -- ४С̥ХåϤ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Memo

  check_file_exists  glade  support.c β¤

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk-pixbuf/gdk-pixbuf-loader.h>

#include "main.h"
#include "lm_rrda.h"
#include "lm_sound_man.h"
#include "rv_data.h"
#include "rv_display.h"
#include "rv_anim.h"

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

/* This is an internally used function to check if a pixmap file exists. */
static gchar* check_file_exists        (const gchar     *directory,
                                        const gchar     *filename);


GdkPixbuf  *graphic_to_pixbuf(gpointer);

void stage_script_read(gint);


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ե̾ΰ */
unsigned char index_file[32][256];

/* --- ե = ơ */
gint  stage_number;

/* --- ơե */
unsigned char *stage_file;

/* --- ơǡ */
unsigned char stage_data[15][256];

/* --- ɥޥ͡㥽å */
int  soundman;

/* --- ĤäƤ BGM ֹ */
int  now_bgm;

/* --- ߤ BGM ǥХ */
int  bgm_device;

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RVDataInit       -- ǡץɤ߹

   return : void
   void

-------------------------------------------------------------- */
void  RVDataInit(void)
{
  gchar  *dir_name, *fullname;

  /* ---- ǡ뤫ɤõ */
  dir_name = g_malloc(strlen(PACKAGE_DATA_DIR)+12);
  strcpy(dir_name, PACKAGE_DATA_DIR);
  strcat(dir_name, G_DIR_SEPARATOR_S);
  strcat(dir_name, DATA_DIR);
  fullname = check_file_exists(dir_name, game_data_name);
  g_free(dir_name);
  if (fullname == NULL) {
    dir_name = g_malloc(strlen(PACKAGE_SOURCE_DIR)+12);
    strcpy(dir_name, PACKAGE_SOURCE_DIR);
    strcat (dir_name, G_DIR_SEPARATOR_S);
    strcat (dir_name, DATA_DIR);
    fullname = check_file_exists(dir_name, game_data_name);
    g_free(dir_name);
  }
  if (fullname == NULL) {
    perror("data path not found.\n");
    exit(-1);
  }
  /* ---- ǡ */
  if (lm_rrda_open(fullname, "LIMO") == FALSE) {
    perror("RRDA: file open error.\n");
    exit(-1);
  }
  RVDataIndex();
  g_free(fullname);

  /* ---- ǡ뤫ɤõ */
  dir_name = g_malloc(strlen(PACKAGE_DATA_DIR)+12);
  strcpy(dir_name, PACKAGE_DATA_DIR);
  strcat (dir_name, G_DIR_SEPARATOR_S);
  strcat (dir_name, DATA_DIR);
  fullname = check_file_exists(dir_name, SOUNDDATA);
  g_free(dir_name);
  if (fullname == NULL) {
    dir_name = g_malloc(strlen(PACKAGE_SOURCE_DIR)+12);
    strcpy(dir_name, PACKAGE_SOURCE_DIR);
    strcat (dir_name, G_DIR_SEPARATOR_S);
    strcat (dir_name, DATA_DIR);
    fullname = check_file_exists(dir_name, SOUNDDATA);
    g_free(dir_name);
  }
  if (fullname == NULL) {
    perror("sound data path not found.\n");
    exit(-1);
  }
  /* ---- ɥɥ饤С */
  soundman = lm_sound_init(fullname, NULL, cd_device_name);
  g_free(fullname);
  now_bgm = 0;
  bgm_device = 0;
}


/* -------------------------------------------------------------
  RVDataIndex       -- ǡץɤ߹

   return : void
   void

-------------------------------------------------------------- */
void  RVDataIndex(void)
{
  unsigned char *index, line[256];
  gint  size;
  gint  i, j, local_line, data_index;
  gboolean empty_flag;
 
  size = (gint)lm_rrda_data_size("startup.scr");
  index = lm_rrda_load_data("startup.scr");

  /* ----- ǥå */
  local_line = 0;
  stage_number = 0;
  for(i=0; i<size; i++) {
    if ((index[i] == 0x0a) || (i == (size - 1)) || (index[i] == '\0')) {
      /* ---- 饤 */
      line[local_line] = 0;
      /* ---  */
      empty_flag = TRUE;
      for(j=0; j<local_line; j++) {
	if ((line[j] != '\n') && (line[j] != '\t') && (line[j] != ' ')) {
	  empty_flag = FALSE;
	}
      }
      data_index = 0;
      if (empty_flag == FALSE) {
	for(j=0; j<local_line; j++) {
	  if ((line[j] != '\n') && (line[j] != '\t') && (line[j] != ' ')) {
	    index_file[stage_number][data_index] = line[j];
	    data_index++;
	  }
	}
	index_file[stage_number][data_index] = '\0';
	stage_number++;
      }
      /* --- ä鼡 */
      local_line = 0;
    }
    else {
      line[local_line] = index[i];
      local_line++;
    }
    if (index[i] == '\0') break;
  }
  stage_number -= 9;
}


/* -------------------------------------------------------------
  RVDataFree       -- ǡ

   return : void
   void

-------------------------------------------------------------- */
void  RVDataFree(void)
{
  if (stage_file != NULL) free(stage_file);
  lm_rrda_close();
  lm_sound_close(soundman);
}


/* -------------------------------------------------------------
  RVDataSoundRequest    -- ɥޥ͡㡼ؤΥꥯ

   return : void
   gchar *

-------------------------------------------------------------- */
void  RVDataSoundRequest(gchar *com)
{
  lm_sound_request(soundman, (char*)com);
}


/* -------------------------------------------------------------
  RVDataBGMRequest      -- BGMΥꥯ

   return : void
   gint  n (0=STOP, 1 BGM No.)

-------------------------------------------------------------- */
void       RVDataBGMRequest(gint n)
{
  /* --- request command */
  gchar comm[64];

  if (bgm_device == 0) {
    if (n == 0) {
      strcpy(comm, "B ALLRESET");
    }
    else {
      sprintf(comm, "B PLAY 0 %d B LOOP 0", n);
    }
  }
  else if (bgm_device == 1) {
    if (n == 0) {
      strcpy(comm, "C STOP");
    }
    else {
      sprintf(comm, "C PLAY %d C LOOP", n);
    }
  }
  else {
    comm[0] = '\0';
  }
  
  RVDataSoundRequest(comm);

  /* --- ͤݻ */
  now_bgm = n;
}


/* -------------------------------------------------------------
  RVDataBGMDevice      -- BGMǥХؤƥ

   return : void
   gint  dev (0=PCM, 1=CDDA)

-------------------------------------------------------------- */
void       RVDataBGMDevice(gint dev)
{
  gint  n;

  if (bgm_device != dev) {
    n = now_bgm;
    RVDataBGMRequest(0);  
    bgm_device = dev;
    RVDataBGMRequest(n);  
  }
}


/* -------------------------------------------------------------
  RVDataStageNum    -- ơ

   return : void
   void

-------------------------------------------------------------- */
gint  RVDataStageNum(void)
{
  return(stage_number);
}


/* -------------------------------------------------------------
  RVDataStage       -- ꥹơΥץȲ

   return : voib
   gint  stage number

-------------------------------------------------------------- */
void  RVDataStage(gint st)
{
  gint s;

  s = st;
  if (s > RVDataStageNum()) {
    s = RVDataStageNum();
  }
  /* ----- ơǡɤ߹ */
  stage_script_read(s);
}


/* -------------------------------------------------------------
  RVDataComLevel   -- ơΥԥ塼ζ

   return : gint level
   void

-------------------------------------------------------------- */
gint       RVDataComLevel(void)
{
  gint com_level;

  sscanf(stage_data[6], "%d", &com_level);
  return(com_level);
}

/* -------------------------------------------------------------
  RVDataKoma       -- ǡμϤ

   return : GdkPixbuf Ϥ
   void

-------------------------------------------------------------- */
GdkPixbuf  *RVDataKoma(void)
{
  return(graphic_to_pixbuf("koma001"));
}


/* -------------------------------------------------------------
  RVDataGrid       -- ܥǡμϤ

   return : GdkPixbuf Ϥ
   void

-------------------------------------------------------------- */
GdkPixbuf  *RVDataGrid(void)
{
  return(graphic_to_pixbuf("grid001"));
}


/* -------------------------------------------------------------
  RVDataTitle      -- ȥ̤Ϥ

   return : GdkPixbuf Ϥ
   void

-------------------------------------------------------------- */
GdkPixbuf *RVDataTitle(void)
{
  return(graphic_to_pixbuf(index_file[0]));
}


/* -------------------------------------------------------------
  RVDataTitleParts    -- ȥ̤Ϥ

   return : GdkPixbuf Ϥ
   void *x, *y ɸ֤Υݥ󥿡

-------------------------------------------------------------- */
GdkPixbuf *RVDataTitleParts(gint *x, gint *y)
{
  gchar  col[256], name[256];
  gint   i, a, b, l;

  a = b = l = 0;
  *x = 0;
  *y = 0;
  l = strlen(index_file[8]) + 1;
  for(i=0; i<l; i++) {
    if ((index_file[8][i] == ',') || (i == (l-1))) {
      col[a] = '\0';
      if (b == 0) {
	strcpy(name, col);
      }
      if (b == 1) {
	sscanf(col, "%d", x);
      }
      if (b == 2) {
	sscanf(col, "%d", y);
      }
      a = 0;
      b++;
    }
    else {
      col[a] = index_file[8][i];
      a++;
    }
  }
  return(graphic_to_pixbuf(name));
}


/* -------------------------------------------------------------
  RVDataCircle     -- Ϥ

   return : GdkPixbuf Ϥ
   void

-------------------------------------------------------------- */
GdkPixbuf *RVDataCircle(void)
{
  return(graphic_to_pixbuf("mark_fumi"));
}


/* -------------------------------------------------------------
  RVDataCircleBack -- ХåϤ

   return : GdkPixbuf Ϥ
   void

-------------------------------------------------------------- */
GdkPixbuf *RVDataCircleBack(void)
{
  return(graphic_to_pixbuf("mark_back"));
}


/* -------------------------------------------------------------
  RVDataContinueBack -- ƥ˥塼̥ХåϤ

   return : GdkPixbuf Ϥ
   void

-------------------------------------------------------------- */
GdkPixbuf *RVDataContinueBack(void)
{
  return(graphic_to_pixbuf(index_file[2]));
}


/* -------------------------------------------------------------
  RVDataContinueParts -- ƥ˥塼̥ѡĤϤ

   return : GdkPixbuf Ϥ
   void

-------------------------------------------------------------- */
GdkPixbuf *RVDataContinueParts(void)
{
  return(graphic_to_pixbuf(index_file[3]));
}


/* -------------------------------------------------------------
  RVDataContinueChara -- ƥ˥塼٤äƤ륭Ϥ

   return : GdkPixbuf Ϥ
   void

-------------------------------------------------------------- */
GdkPixbuf *RVDataContinueChara(void)
{
  return(graphic_to_pixbuf(index_file[4]));
}


/* -------------------------------------------------------------
  RVDataGameover -- ४С̥ХåϤ

   return : GdkPixbuf Ϥ
   void

-------------------------------------------------------------- */
GdkPixbuf *RVDataGameover(void)
{
  return(graphic_to_pixbuf(index_file[1]));
}


/* -------------------------------------------------------------
  RVDataAllclear -- ̥ꥢ̤Ϥ

   return : GdkPixbuf Ϥ
   void

-------------------------------------------------------------- */
GdkPixbuf *RVDataAllclear(void)
{
  return(graphic_to_pixbuf(index_file[7]));
}


/* -------------------------------------------------------------
  RVDataBreaktime -- ֥졼ѥǡϤ

   return : GdkPixbuf Ϥ
   void

-------------------------------------------------------------- */
void       RVDataBreaktime(RVBREAK *pack)
{
  pack->back = graphic_to_pixbuf(index_file[5]);
  pack->parts = graphic_to_pixbuf(index_file[6]);
  /* ===== ơ˰ۤʤϤ */
  pack->picture = graphic_to_pixbuf(stage_data[5]);
}




/* -------------------------------------------------------------
  RVDataStageGraphic   -- ơͭΥǡ

   return : void
   void

-------------------------------------------------------------- */
void  RVDataStageGraphic(void)
{
  RVDispLoadBoard(graphic_to_pixbuf(stage_data[0]));
  RVDispLoadShade(graphic_to_pixbuf(stage_data[1]));
  RVDispLoadScore(graphic_to_pixbuf(stage_data[2]));
  RVDispLoadInfo(graphic_to_pixbuf(stage_data[3]));
  RVDispLoadChara(graphic_to_pixbuf(stage_data[4]));
  RVDispLoadPicture(graphic_to_pixbuf(stage_data[5]));
}



/*=================================================================*/
/*  ʥ֥롼                                         */
/*=================================================================*/

/* -------------------------------------------------------------
  check_file_exists -- ե¸߳ǧ
-------------------------------------------------------------- */
/* This is an internally used function to check if a pixmap file exists. */
gchar*
check_file_exists                      (const gchar     *directory,
                                        const gchar     *filename)
{
  gchar *full_filename;
  struct stat s;
  gint status;

  full_filename = (gchar*) g_malloc (strlen (directory) + 1
                                     + strlen (filename) + 1);
  strcpy (full_filename, directory);
  strcat (full_filename, G_DIR_SEPARATOR_S);
  strcat (full_filename, filename);

  status = stat (full_filename, &s);
  if (status == 0 && S_ISREG (s.st_mode))
    return full_filename;
  g_free (full_filename);
  return NULL;
}


/* -------------------------------------------------------------
  graphic_to_pixbuf      -- ǡɤ߹

   return : GdkPixbuf  *
   dat - ǡ̾

-------------------------------------------------------------- */
GdkPixbuf  *graphic_to_pixbuf(gpointer dat)
{
  GdkPixbuf  *pb;
  GdkPixbufLoader *loader;
  gint  size;
  gpointer   *data;

  size = lm_rrda_data_size(dat);
  if (size == 0) {
    fprintf(stderr, "RRDA: Data read error (%s)\n", (char*)dat);
    exit(-1);
  }
  data = lm_rrda_load_data(dat);
  loader = gdk_pixbuf_loader_new();
  if (gdk_pixbuf_loader_write(loader, (guchar*)data, size) == FALSE) {
    fprintf(stderr, "RRDA: Data read error (%s)\n", (char*)dat);
    exit(-1);
  }
  pb = gdk_pixbuf_loader_get_pixbuf(loader);
  gdk_pixbuf_loader_close(loader);
  free(data);

  return(pb);
}


/* -------------------------------------------------------------
  stage_script_read     -- ơǡɤ߹

   return : void
   st - ɤ߹ॹơ

-------------------------------------------------------------- */
void stage_script_read(gint st)
{
  unsigned char line[256], *anim_ptr;
  gint  size;
  gint  i, j, local_line, mode;
  gint  anim_frame;
 
  if (stage_file != NULL) free(stage_file);
  size = lm_rrda_data_size(index_file[9+st]);
  stage_file = lm_rrda_load_data(index_file[9+st]);

  anim_frame = 0;
  anim_ptr = 0;

  /* ----- ǥå */
  local_line = 0;
  mode = 0;
  for(i=0; i<size; i++) {
    if ((stage_file[i] == 0x0a) || (i == (size - 1)) || (stage_file[i] == '\0')) {
      /* ---- 饤 */
      line[local_line] = 0;
      /* ---  */
      if (local_line > 0) {
	if (line[0] != '\\') {
	  if (mode < 7) {
	    for(j=0; j<(local_line+1); j++) {
	      stage_data[mode][j] = line[j];
	    }
	  }
	  else {
	    anim_frame++;
	  }
	}
	else {
	  if (strncmp(line, "\\back_picture", 256) == 0) {
	    mode = 0;
	  }
	  else if (strncmp(line, "\\shadeback_picture", 256) == 0) {
	    mode = 1;
	  }
	  else if (strncmp(line, "\\scoreboard_picture", 256) == 0) {
	    mode = 2;
	  }
	  else if (strncmp(line, "\\object_picture", 256) == 0) {
	    mode = 3;
	  }
	  else if (strncmp(line, "\\character_face", 256) == 0) {
	    mode = 4;
	  }
	  else if (strncmp(line, "\\moemoe_picture", 256) == 0) {
	    mode = 5;
	  }
	  else if (strncmp(line, "\\com_level", 256) == 0) {
	    mode = 6;
	  }
	  else if (strncmp(line, "\\face_animation_1", 256) == 0) {
	    if (mode >= 7) {
	      RVAnimDataSet(stage_file, anim_ptr, (mode-7), anim_frame);
	    }
	    mode = 7;
	    anim_frame = 0;
	    anim_ptr = &stage_file[i+1];
	  }
	  else if (strncmp(line, "\\face_animation_2", 256) == 0) {
	    if (mode >= 7) {
	      RVAnimDataSet(stage_file, anim_ptr, (mode-7), anim_frame);
	    }
	    mode = 8;
	    anim_frame = 0;
	    anim_ptr = &stage_file[i+1];
	  }
	  else if (strncmp(line, "\\face_animation_3", 256) == 0) {
	    if (mode >= 7) {
	      RVAnimDataSet(stage_file, anim_ptr, (mode-7), anim_frame);
	    }
	    mode = 9;
	    anim_frame = 0;
	    anim_ptr = &stage_file[i+1];
	  }
	  else if (strncmp(line, "\\face_animation_4", 256) == 0) {
	    if (mode >= 7) {
	      RVAnimDataSet(stage_file, anim_ptr, (mode-7), anim_frame);
	    }
	    mode = 10;
	    anim_frame = 0;
	    anim_ptr = &stage_file[i+1];
	  }
	  else if (strncmp(line, "\\face_animation_5", 256) == 0) {
	    if (mode >= 7) {
	      RVAnimDataSet(stage_file, anim_ptr, (mode-7), anim_frame);
	    }
	    mode = 11;
	    anim_frame = 0;
	    anim_ptr = &stage_file[i+1];
	  }
	  else if (strncmp(line, "\\face_animation_6", 256) == 0) {
	    if (mode >= 7) {
	      RVAnimDataSet(stage_file, anim_ptr, (mode-7), anim_frame);
	    }
	    mode = 12;
	    anim_frame = 0;
	    anim_ptr = &stage_file[i+1];
	  }
	  else if (strncmp(line, "\\face_animation_7", 256) == 0) {
	    if (mode >= 7) {
	      RVAnimDataSet(stage_file, anim_ptr, (mode-7), anim_frame);
	    }
	    mode = 13;
	    anim_frame = 0;
	    anim_ptr = &stage_file[i+1];
	  }
	  else if (strncmp(line, "\\face_animation_8", 256) == 0) {
	    if (mode >= 7) {
	      RVAnimDataSet(stage_file, anim_ptr, (mode-7), anim_frame);
	    }
	    mode = 14;
	    anim_frame = 0;
	    anim_ptr = &stage_file[i+1];
	  }
	  else if (strncmp(line, "\\end", 256) == 0) {
	    if (mode >= 7) {
	      RVAnimDataSet(stage_file, anim_ptr, (mode-7), anim_frame);
	    }
	    break;
	  }
	}
      }
      /* --- ä鼡 */
      local_line = 0;
    }
    else {
      if ((stage_file[i] != '\n') && (stage_file[i] != '\t') && (stage_file[i] != ' ')) {
	line[local_line] = stage_file[i];
	local_line++;
      }
    }
    if (stage_file[i] == '\0') break;
  }
}
