/* =====================================================================

   LiMo Reversi 
      Display System.  - ɽνʬ

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Nov.23.1999  Programing start
  Dec.04.1999  褽ΥѡĤ
  May.31.2000  ܻؤƺƻư
  Jun.06.2000  ܡɤοɲ
  Jun.07.2000  ѥΥե᡼
  Jun.08.2000  ѥե᡼٤Τǹ®

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RVDispInit          -- Pixmap ʤɽ
  RVDispFree          -- ̼곫(˺줺)
  RVDispLoadBoard     -- ץǡ
  RVDispLoadShade     -- Ťץǡ(դ)
  RVDispLoadChara     -- Υեå
  RVDispLoadPicture   -- طʥեåμ
  RVDispLoadInfo      -- ȤΥե᡼ѡ
  RVDispDrawAll       -- ѡ
  RVDispDraw          -- ɬפʤȤ
  RVDispLightMode     -- ɽ̲⡼ɥå
  RVDispScoreSet      -- ܡɤοѹ/
  RVDispScorePos      -- ܡɤΰֻ
  RVDispCharaSet      -- 饯Υѥ
  RVDispCharaPos      -- 饯ΰֻ
  RVDispInfoPos       -- ե᡼ΰֻ
  RVDispKoma          -- ܡɾζɽ
  RVDispKomaAnim      -- ˥ζɽ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include "rr_screen.h"
#include "rr_spriteman.h"
#include "rv_board.h"
#include "rv_data.h"
#include "rv_display.h"


/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* --- XPM Pointer name. */
#define  KOMA_XPM  koma_xpm

/* --- Ҥä꤫ꥢ˥᡼󥷡 12޸ */
const gint anim_seq[13] = {
  8, 7, 7, 6, 5, 4,
  3, 2, 2, 1, 1, 0, 0
};

/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

/* --- ط(ܡ)ɽ */
void  koma_back(gint);

/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ܡɽ */
static  gint  score_x, score_y;

/* --- եɽ̥⡼ */
static  gboolean  light_mode = FALSE;

/* -------------------------------------------------------------
 --- ե꡼Хåե
-------------------------------------------------------------- */

/* --- ܡ */
static  GdkPixmap  *board_pix;
static  RRSObj     *board_sprite;
static  GdkPixmap  *grid_pix;
static  GdkBitmap  *grid_mask;

/* --- ζ */
static  GdkPixmap  *koma_pix;
static  GdkBitmap  *koma_mask;

/* --- طʤγ */
static  GdkPixmap  *picture_pix;

/* --- طʤγȥޤȥޥ */
static  RRSObj     *koma_sprite[64];
static  RRSObj     *grid_sprite[64];
static  RRSObj     *under_sprite[64];

/* --- ܡ */
static  GdkPixmap  *score_pix;
static  GdkPixmap  *score_info;
static  GdkBitmap  *info_mask;
static  RRSObj     *score_sprite;
static  RRSObj     *score_num[4];
static  RRSObj     *info_board;
static  RRSObj     *shade_sprite1;

/* --- 饯ѡ */
static  GdkPixmap  *chara_pix;
static  GdkBitmap  *chara_mask;
static  RRSObj     *chara_sprite;
static  RRSObj     *shade_sprite2;

/* --- ѡĤα */
static  GdkPixmap  *shade_pix;

/* --- ʰɽ */
static  GdkPixmap  *light_pix;

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* ----------------------------------------------------
  Pixmap 
------------------------------------------------------- */

/* -------------------------------------------------------------
  RVDispInit       -- (ʤꤸ塼衼)

   return : void
   void

-------------------------------------------------------------- */
void  RVDispInit(void)
{
  GdkPixbuf *pix;
  gint  i;

  /* -- SPRITE ޥ͡㡼 */
  RRSpritemanInit();

  /* --  pixmap  */
  pix = RVDataKoma();
  gdk_pixbuf_render_pixmap_and_mask(pix, &koma_pix, &koma_mask, 128);
  gdk_pixbuf_unref(pix);

  /* -- ܡɤΥå */
  pix = RVDataGrid();
  gdk_pixbuf_render_pixmap_and_mask(pix, &grid_pix, &grid_mask, 128);
  gdk_pixbuf_unref(pix);

  /* -- ץ饤 */
  for(i=0; i<64; i++) {
    koma_sprite[i] = RRSpritemanNew();
    koma_sprite[i]->sw = FALSE;
    koma_sprite[i]->update = TRUE;
    koma_sprite[i]->z  = 3000;
    koma_sprite[i]->obj.sw = TRUE;
    koma_sprite[i]->obj.mask_offset = TRUE;
    koma_sprite[i]->obj.objmap = koma_pix;
    koma_sprite[i]->obj.objmask = koma_mask;
    koma_sprite[i]->obj.x = 8 + ((i % 8) * 58);
    koma_sprite[i]->obj.y = 8 + ((i / 8) * 58);
    koma_sprite[i]->obj.ox = 0;
    koma_sprite[i]->obj.oy = 0;
    koma_sprite[i]->obj.offset_x = 0;
    koma_sprite[i]->obj.offset_y = 0;
    koma_sprite[i]->obj.w = 58;
    koma_sprite[i]->obj.h = 58;
    grid_sprite[i] = RRSpritemanNew();
    grid_sprite[i]->sw = TRUE;
    grid_sprite[i]->update = TRUE;
    grid_sprite[i]->z  = 6000;
    grid_sprite[i]->obj.sw = TRUE;
    grid_sprite[i]->obj.mask_offset = TRUE;
    grid_sprite[i]->obj.objmap = grid_pix;
    grid_sprite[i]->obj.objmask = grid_mask;
    grid_sprite[i]->obj.x = 8 + ((i % 8) * 58);
    grid_sprite[i]->obj.y = 8 + ((i / 8) * 58);
    grid_sprite[i]->obj.ox = ((i % 8) * 58);
    grid_sprite[i]->obj.oy = ((i / 8) * 58);
    grid_sprite[i]->obj.offset_x = 0;
    grid_sprite[i]->obj.offset_y = 0;
    grid_sprite[i]->obj.w = 58;
    grid_sprite[i]->obj.h = 58;
    under_sprite[i] = NULL;
  }


  /* -- ¾ */
  board_pix = picture_pix = chara_pix = shade_pix = score_pix =NULL;
  score_info = light_pix = NULL;
  board_sprite = score_sprite = chara_sprite = info_board = NULL;
  score_num[0] = score_num[1] = score_num[2] = score_num[3] = NULL;
  shade_sprite1 = shade_sprite2 = NULL;
  light_mode = FALSE;
}


/* -------------------------------------------------------------
  RVDispFree          -- ̼곫(˺줺)

   return : void
   void

-------------------------------------------------------------- */
void  RVDispFree(void)
{
  if (koma_pix != NULL) gdk_pixmap_unref(koma_pix);
  if (koma_mask != NULL) gdk_bitmap_unref(koma_mask);
  if (grid_pix != NULL) gdk_pixmap_unref(grid_pix);
  if (grid_mask != NULL) gdk_bitmap_unref(grid_mask);
  if (score_pix != NULL) gdk_pixmap_unref(score_pix);
  if (board_pix != NULL) gdk_pixmap_unref(board_pix);
  if (picture_pix != NULL) gdk_pixmap_unref(picture_pix);
  if (chara_pix != NULL) gdk_pixmap_unref(chara_pix);
  if (chara_mask != NULL) gdk_bitmap_unref(chara_mask);
  if (shade_pix != NULL) gdk_pixmap_unref(shade_pix);
  if (score_info != NULL) gdk_pixmap_unref(score_info);
  if (light_pix != NULL) gdk_pixmap_unref(light_pix);

  /* -- SPRITE ޥ͡㡼 */
  RRSpritemanFree();
}


/* -------------------------------------------------------------
  RVDispLoadBoard     -- ץǡ

   return : void
   GPointer *xpm_data : XPMǡΥݥ󥿡

-------------------------------------------------------------- */
void  RVDispLoadBoard(GdkPixbuf *xpm_data)
{
  RRSprite *sp;

  if (board_pix != NULL) gdk_pixmap_unref(board_pix);
  gdk_pixbuf_render_pixmap_and_mask(xpm_data, &board_pix, NULL, 128);
  gdk_pixbuf_unref(xpm_data);
  RRSpritemanBGColor(0x0000, 0xf000, 0x6000);

  /* -- Хåѥͥ륹ץ饤 */
  if (board_sprite != NULL) {
    RRSpritemanBGDestroy(board_sprite);
  }
  board_sprite = RRSpritemanBGNew();
  board_sprite->sw = TRUE;
  board_sprite->update = TRUE;
  board_sprite->z  = 10000;
  sp = &board_sprite->obj;
  sp->sw = TRUE;
  sp->mask_offset = TRUE;
  sp->objmap = board_pix;
  sp->objmask = NULL;
  sp->x = sp->y = 0;
  sp->ox = sp->oy = 0;
  sp->offset_x = sp->offset_y = 0;
  sp->w = 640;
  sp->h = 480;
}

/* -------------------------------------------------------------
  RVDispLoadShade     -- Ťץǡ(դ)

   return : void
   GPointer *xpm_data : XPMǡΥݥ󥿡

-------------------------------------------------------------- */
void  RVDispLoadShade(GdkPixbuf *xpm_data)
{
  if (shade_pix != NULL) gdk_pixmap_unref(shade_pix);
  gdk_pixbuf_render_pixmap_and_mask(xpm_data, &shade_pix, NULL, 128);
  gdk_pixbuf_unref(xpm_data);
}

/* -------------------------------------------------------------
  RVDispLoadScore     -- ܡɥǡ

   return : void
   GPointer *xpm_data : XPMǡΥݥ󥿡

-------------------------------------------------------------- */
void  RVDispLoadScore(GdkPixbuf *xpm_data)
{
  RRSprite *sp;

  if (score_pix != NULL) gdk_pixmap_unref(score_pix);
  gdk_pixbuf_render_pixmap_and_mask(xpm_data, &score_pix, NULL, 128);
  gdk_pixbuf_unref(xpm_data);

  /* -- ܡɥץ饤 */
  if (score_sprite != NULL) {
    RRSpritemanDestroy(score_sprite);
  }
  score_sprite = RRSpritemanNew();
  score_sprite->sw = TRUE;
  score_sprite->update = TRUE;
  score_sprite->z  = 1000;
  sp = &score_sprite->obj;
  sp->sw = TRUE;
  sp->mask_offset = TRUE;
  sp->objmap = score_pix;
  sp->objmask = NULL;
  sp->x = 800;
  sp->y = 100;
  sp->ox = sp->oy = 0;
  sp->offset_x = sp->offset_y = 0;
  sp->w = 150;
  sp->h = 140;
  if (shade_sprite1 != NULL) {
    RRSpritemanDestroy(shade_sprite1);
  }
  shade_sprite1 = RRSpritemanNew();
  shade_sprite1->sw = TRUE;
  shade_sprite1->update = TRUE;
  shade_sprite1->z  = 2000;
  sp = &shade_sprite1->obj;
  sp->sw = TRUE;
  sp->mask_offset = TRUE;
  sp->objmap = shade_pix;
  sp->objmask = NULL;
  sp->x = 800;
  sp->y = 100;
  sp->ox = sp->x;
  sp->oy = sp->y;
  sp->offset_x = sp->offset_y = 0;
  sp->w = 150;
  sp->h = 140;
}

/* -------------------------------------------------------------
  RVDispLoadChara     -- Υեå

   return : void
   GPointer *xpm_data : XPMǡΥݥ󥿡

-------------------------------------------------------------- */
void  RVDispLoadChara(GdkPixbuf *xpm_data)
{
  RRSprite *sp;

  if (chara_pix != NULL) gdk_pixmap_unref(chara_pix);
  if (chara_mask != NULL) gdk_bitmap_unref(chara_mask);
  gdk_pixbuf_render_pixmap_and_mask(xpm_data, &chara_pix, &chara_mask, 128);
  gdk_pixbuf_unref(xpm_data);

  /* -- 鳨ץ饤 */
  if (chara_sprite != NULL) {
    RRSpritemanDestroy(chara_sprite);
  }
  chara_sprite = RRSpritemanNew();
  chara_sprite->sw = TRUE;
  chara_sprite->update = TRUE;
  chara_sprite->z  = 1000;
  sp = &chara_sprite->obj;
  sp->sw = TRUE;
  sp->mask_offset = TRUE;
  sp->objmap = chara_pix;
  sp->objmask = chara_mask;
  sp->x = 500;
  sp->y = 0;
  sp->ox = sp->oy = 0;
  sp->offset_x = sp->offset_y = 0;
  sp->w = 140;
  sp->h = 200;
  if (shade_sprite2 != NULL) {
    RRSpritemanDestroy(shade_sprite2);
  }
  shade_sprite2 = RRSpritemanNew();
  shade_sprite2->sw = TRUE;
  shade_sprite2->update = TRUE;
  shade_sprite2->z  = 2000;
  sp = &shade_sprite2->obj;
  sp->sw = TRUE;
  sp->mask_offset = FALSE;
  sp->objmap = shade_pix;
  sp->objmask = chara_mask;
  sp->x = 500;
  sp->y = 0;
  sp->ox = sp->x;
  sp->oy = sp->y;
  sp->offset_x = sp->offset_y = 0;
  sp->w = 140;
  sp->h = 200;
}

/* -------------------------------------------------------------
  RVDispLoadPicture   -- طʥեåμ

   return : void
   GPointer *xpm_data : XPMǡΥݥ󥿡

-------------------------------------------------------------- */
void  RVDispLoadPicture(GdkPixbuf *xpm_data)
{
  gint  i;

  if (picture_pix != NULL) gdk_pixmap_unref(picture_pix);
  gdk_pixbuf_render_pixmap_and_mask(xpm_data, &picture_pix, NULL, 128);
  gdk_pixbuf_unref(xpm_data);

  /* -- ץ饤 */
  for(i=0; i<64; i++) {
    if (under_sprite[i] != NULL) {
      RRSpritemanDestroy(under_sprite[i]);
    }
    under_sprite[i] = RRSpritemanNew();
    under_sprite[i]->sw = FALSE;
    under_sprite[i]->update = TRUE;
    under_sprite[i]->z  = 8000;
    under_sprite[i]->obj.sw = TRUE;
    under_sprite[i]->obj.mask_offset = TRUE;
    under_sprite[i]->obj.objmap = picture_pix;
    under_sprite[i]->obj.objmask = NULL;
    under_sprite[i]->obj.x = 8 + ((i % 8) * 58);
    under_sprite[i]->obj.y = 8 + ((i / 8) * 58);
    under_sprite[i]->obj.ox = ((i % 8) * 58);
    under_sprite[i]->obj.oy = ((i / 8) * 58);
    under_sprite[i]->obj.offset_x = 0;
    under_sprite[i]->obj.offset_y = 0;
    under_sprite[i]->obj.w = 58;
    under_sprite[i]->obj.h = 58;
  }
}


/* -------------------------------------------------------------
  RVDispLoadInfo      -- ȤΥե᡼ѡ

   return : void
   GPdkPixbuf *pix_data : ǡΥݥ󥿡

-------------------------------------------------------------- */
void  RVDispLoadInfo(GdkPixbuf *pix_data)
{
  gint  i;

  if (score_info != NULL) gdk_pixmap_unref(score_info);
  gdk_pixbuf_render_pixmap_and_mask(pix_data, &score_info, &info_mask, 128);
  gdk_pixbuf_unref(pix_data);

  /* -- ʥСץ饤 */
  for(i=0; i<4; i++) {
    if (score_num[i] != NULL) {
      RRSpritemanDestroy(score_num[i]);
    }
    score_num[i] = RRSpritemanNew();
    score_num[i]->sw = TRUE;
    score_num[i]->update = TRUE;
    score_num[i]->z  = 900;
    score_num[i]->obj.sw = TRUE;
    score_num[i]->obj.mask_offset = TRUE;
    score_num[i]->obj.objmap = score_info;
    score_num[i]->obj.objmask = info_mask;
    score_num[i]->obj.x = 800;
    score_num[i]->obj.y = 100;
    score_num[i]->obj.ox = score_num[i]->obj.oy = 0;
    score_num[i]->obj.offset_x = score_num[i]->obj.offset_y = 0;
    score_num[i]->obj.w = 24;
    score_num[i]->obj.h = 48;
  }
  /* -- win/lose/pass ե᡼󥹥ץ饤 */
  if (info_board != NULL) {
    RRSpritemanDestroy(info_board);
  }
  info_board = RRSpritemanNew();
  info_board->sw = FALSE;
  info_board->update = FALSE;
  info_board->z  = 100;
  info_board->obj.sw = FALSE;
  info_board->obj.mask_offset = TRUE;
  info_board->obj.objmap = score_info;
  info_board->obj.objmask = info_mask;
  info_board->obj.x = 800;
  info_board->obj.y = 100;
  info_board->obj.ox = info_board->obj.oy = 0;
  info_board->obj.offset_x = info_board->obj.offset_y = 0;
  info_board->obj.w = 160;
  info_board->obj.h = 100;
}


/* ----------------------------------------------------
  ɽ
------------------------------------------------------- */
/* -------------------------------------------------------------
  RVDispDrawAll   -- ѡ

   return : void
   void

-------------------------------------------------------------- */
void  RVDispDrawAll(void)
{
  board_sprite->update = TRUE;
  RVDispDraw();
}

/* -------------------------------------------------------------
  RVDispDraw      -- ɬפʤȤ

   return : void
   void

-------------------------------------------------------------- */
void  RVDispDraw(void)
{

  if (light_mode == FALSE) {
    /* -- ɽ */
    RVDispKoma();
    
    /* --- ˥᡼ζɽ(Υ˥᡼ɽ) */
    RVDispKomaAnim();
  }
  /* --- ।ե᡼(You Win Ȥ) */

  /* -- ץ饤ȴɽ */
  RRSpritemanAutoUpdate(0);
}

/* -------------------------------------------------------------
  RVDispLightMode   -- ɽ̲⡼ɥå

   return : void
   gboolean  sw

-------------------------------------------------------------- */
void  RVDispLightMode(gboolean sw)
{
  gint  i;
  RVKoma  *koma;

  if ((light_mode == FALSE) && (sw == TRUE)) {
    light_pix = RRScreenBufferDisp();
    for(i=0; i<64; i++) {
      koma_sprite[i]->sw = FALSE;
      koma_sprite[i]->obj.sw = FALSE;
      under_sprite[i]->sw = FALSE;
      under_sprite[i]->obj.sw = FALSE;
      grid_sprite[i]->obj.objmap = light_pix;
      grid_sprite[i]->obj.objmask = NULL;
      grid_sprite[i]->obj.ox = 8 + ((i % 8) * 58);
      grid_sprite[i]->obj.oy = 8 + ((i / 8) * 58);
    }
  }
  if ((light_mode == TRUE) && (sw == FALSE)) {
    if (light_pix != NULL) gdk_pixmap_unref(light_pix);
    for(i=0; i<64; i++) {
      koma = RVBoardKoma(i);
      if (koma->stat > 0) {
	koma_sprite[i]->sw = TRUE;
	koma_sprite[i]->obj.sw = TRUE;
	if (koma->stat == 2) {
	  under_sprite[i]->sw = TRUE;
	  under_sprite[i]->obj.sw = TRUE;
	}
      }
      grid_sprite[i]->obj.objmap = grid_pix;
      grid_sprite[i]->obj.objmask = grid_mask;
      grid_sprite[i]->obj.ox = ((i % 8) * 58);
      grid_sprite[i]->obj.oy = ((i / 8) * 58);
    }
  }
  light_mode = sw;
}


/* ----------------------------------------------------
   ɽƤѹ
------------------------------------------------------- */
/* -------------------------------------------------------------
  RVDispScoreSet      -- ܡɤοѹ/

   return : void
   gint x, y ()

-------------------------------------------------------------- */
void  RVDispScoreSet(gint p1, gint p2)
{
  score_num[0]->obj.ox = (p2 / 10) * 24;
  score_num[1]->obj.ox = (p2 % 10) * 24;
  score_num[2]->obj.ox = (p1 / 10) * 24;
  score_num[3]->obj.ox = (p1 % 10) * 24;
}


/* -------------------------------------------------------------
  RVDispCharaSet      -- 饯鳨ѹ/

   return : void
   gint x, y ()

-------------------------------------------------------------- */
void  RVDispCharaSet(gint p)
{
  chara_sprite->obj.ox = p * 140;
  chara_sprite->update =TRUE;
}


/* ----------------------------------------------------
   ɽ֤λ
------------------------------------------------------- */
/* -------------------------------------------------------------
  RVDispScorePos      -- ܡɤΰֻ

   return : void
   gint x, y ()

-------------------------------------------------------------- */
void  RVDispScorePos(gint x, gint y)
{
  score_x = x;
  score_y = y;
  score_sprite->obj.x = x;
  score_sprite->obj.y = y;
  shade_sprite1->obj.x = x + 4;
  shade_sprite1->obj.y = y + 4;
  shade_sprite1->obj.ox = shade_sprite1->obj.x;
  shade_sprite1->obj.oy = shade_sprite1->obj.y;
  /* -- Υѡ()Ϣư */
  score_num[0]->obj.x = x + 90;
  score_num[0]->obj.y = y + 18;
  score_num[1]->obj.x = x + 114;
  score_num[1]->obj.y = y + 18;
  score_num[2]->obj.x = x + 90;
  score_num[2]->obj.y = y + 78;
  score_num[3]->obj.x = x + 114;
  score_num[3]->obj.y = y + 78;
}


/* -------------------------------------------------------------
  RVDispCharaPos      -- 饯ΰֻ

   return : void
   gint x, y ()

-------------------------------------------------------------- */
void  RVDispCharaPos(gint x, gint y)
{
  chara_sprite->obj.x = x;
  chara_sprite->obj.y = y;
  shade_sprite2->obj.x = x + 6;
  shade_sprite2->obj.y = y + 6;
  shade_sprite2->obj.ox = shade_sprite2->obj.x;
  shade_sprite2->obj.oy = shade_sprite2->obj.y;
}


/* -------------------------------------------------------------
  RVDispInfoDisp       -- ѥ価餱ɽ

   return : void
   gint x, y ()

-------------------------------------------------------------- */
void  RVDispInfoDisp(gint info)
{
  if (info == 0) {
    info_board->sw = FALSE;
    info_board->obj.sw = FALSE;
    info_board->obj.x = 800;
    info_board->obj.y = 480;
    info_board->obj.offset_x = 150;
    info_board->obj.offset_y = 50;
  }
  else {
    info_board->sw = TRUE;
    info_board->obj.sw = TRUE;
    info_board->obj.x = 640;
    info_board->obj.y = 480;
    info_board->obj.ox = 0;
    info_board->obj.oy = ((info - 1) * 100) + 48;
    info_board->obj.offset_x = 150;
    info_board->obj.offset_y = 50;
  }
}


/* -------------------------------------------------------------
  RVDispInfoPos       -- ѥ価餱ΰֻ

   return : void
   gint x, y ()

-------------------------------------------------------------- */
void  RVDispInfoPos(gint x, gint y)
{
  info_board->obj.x = x;
  info_board->obj.y = y;
}





/* ----------------------------------------------------
  פɽ
------------------------------------------------------- */
/* -------------------------------------------------------------
  RVDispKoma          -- ܡɾζɽ

   return : void
   void

-------------------------------------------------------------- */
void  RVDispKoma(void)
{
  gint  i;
 /* ---  */
  RVKoma  *koma;

  for(i=0; i<64; i++) {
    koma = RVBoardKoma(i);
    if (koma->update == TRUE) {
      koma->update = FALSE;
      if (koma->anim_flag == FALSE) {
	koma_back(i);
	switch(koma->stat) {
	case 1:
	  koma_sprite[i]->sw = TRUE;
	  koma_sprite[i]->obj.sw = TRUE;
	  koma_sprite[i]->obj.ox = 0;
	  koma_sprite[i]->obj.oy = 58*4;
	  break;
	case 2:
	  koma_sprite[i]->sw = TRUE;
	  koma_sprite[i]->obj.sw = TRUE;
	  koma_sprite[i]->obj.ox = 58;
	  koma_sprite[i]->obj.oy = 58*4;
	  break;
	default:
	  koma_sprite[i]->sw = FALSE;
	  koma_sprite[i]->obj.sw = FALSE;
	  koma_sprite[i]->obj.ox = 0;
	  koma_sprite[i]->obj.oy = 0;
	}
      }
    }
  }
}


/* -------------------------------------------------------------
  RVDispKomaAnim      -- ˥ζɽ

   return : void
   void

-------------------------------------------------------------- */
void  RVDispKomaAnim(void)
{
  gint  i, p=0;
 /* ---  */
  RVKoma  *koma;

  for(i=0; i<64; i++) {
    koma = RVBoardKoma(i);
    if (koma->anim_flag == TRUE) {
      /* ---  */
      p = anim_seq[koma->anim_timer];
      koma_sprite[i]->sw = TRUE;
      koma_sprite[i]->obj.sw = TRUE;
      koma_sprite[i]->obj.ox = 58 * p;
      koma_sprite[i]->obj.oy = 58 * koma->anim_num;
    }
  }
}


/* -------------------------------------------------------------
  koma_back       -- طɽ

   return : void
   gint pos (ΰ 063)

-------------------------------------------------------------- */
void  koma_back(gint pos)
{
  /* ---  */
  RVKoma  *koma;

  /* ---  */
  koma = RVBoardKoma(pos);
  switch(koma->stat) {
  case 2:
    under_sprite[pos]->sw = TRUE;
    under_sprite[pos]->obj.sw = TRUE;
    under_sprite[pos]->update = TRUE;
    break;
  default:
    under_sprite[pos]->sw = FALSE;
    under_sprite[pos]->obj.sw = FALSE;
    under_sprite[pos]->update = TRUE;
    break;
  }
}


