/* =====================================================================

   LiMo Reversi 
      Reversi Main.  - 

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Nov.23.1999  Programing start
  Dec.04.1999  Ȥߤͷ٤٥ޤǺ
  Jun.08.2000  PASS 価Ԥʤɥե­
  Feb.28.2001  ॹȻܥɲ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RVGameInit         -- Ƽ
  RVGameMain         -- С

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <math.h>
#include <time.h>
#include <gtk/gtk.h>
#include "rr_main.h"
#include "rr_input.h"
#include "rv_game.h"
#include "rv_board.h"
#include "rv_display.h"
#include "rv_data.h"
#include "rv_anim.h"
#include "rv_com.h"

/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* --- ƥåץ٥ -  */
enum {
  G_NULL = 0,
  G_INIT,
  G_WAIT,
  G_INTRO,
  G_MAIN,
  G_GAME_END,
  G_P_WIN,
  G_P_LOSE,
  G_DRAW,
  G_END
};

/* --- ƥåץ٥ - СΥ */
enum {
  T_NULL = 0,
  T_P1_INIT,
  T_P1_PUT,
  T_P1_PUTANIM,
  T_P1_ANIM,
  T_P1_PASS_BEFORE,
  T_P1_PASS,
  T_P2_INIT,
  T_P2_PUT,
  T_P2_PUTANIM,
  T_P2_ANIM,
  T_P2_PASS_BEFORE,
  T_P2_PASS,
  T_END
};

/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

/* --- ᥤ */
void  game_turn(void);
gint  control_input(gint);
void  com_start(gint);
void  game_score(void);
gint  game_winner(void);
gboolean game_finish(void);


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ʤȤʤƤ */
static gint  localtimer;
static gint  wait;
static gint  ttimer;

/* --- ץʹԥƥå */
static gint  game_step;
static gboolean  game_stat;

/* --- ߲̤ˤ */
static gint  game_stage;

/* --- ԥ塼ζ */
static gint  com_level;

/* --- ʹԥƥå */
static gint  turn_step;

/* --- ȤȤƤ */
static gint  pos_keep;

/* --- ץ쥤䡼ȥʤ (0=Player, 1=COM level) */
static gint  p1_cont, p2_cont;

/* --- 潪λȽ */
static gint  pass_count;

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RVGameInit       -- 

   return : void
   void

-------------------------------------------------------------- */
void  RVGameInit(gint stage)
{
  localtimer = 0;
  game_step = G_INIT;
  game_stat = GAME_DOING;
  game_stage = stage;

  /* --- ơ */
  RVDataStage(stage);
  com_level = RVDataComLevel();

  /* --- ɽν */
  RVDispInit();
}


/* -------------------------------------------------------------
  RVGameFree       -- 

   return : void
   void

-------------------------------------------------------------- */
void  RVGameFree(void)
{
  /* --- ɽθ */
  RVDispFree();
}


/* -------------------------------------------------------------
  RVGameStat       -- ʹɤ߼

   return : gboolean ¹ե饰
   void

-------------------------------------------------------------- */
gint  RVGameStat(void)
{
  return(game_stat);
}


/* -------------------------------------------------------------
  RVGameMain       -- СΥե

   return : void
   void

-------------------------------------------------------------- */
void  RVGameMain(void)
{
  RRClick *click;
  gint t;


  localtimer++;

  /* -----------------------------------------------
     ॹƥå׽
   ------------------------------------------------ */
  switch(game_step) {
  case G_INIT:
    /* --  */
    RVDataStageGraphic();
    RVBoardInit();
    RVDispScoreSet(2, 2);
    RVDispScorePos(484, 12 - 4*40);
    RVDispCharaPos(488 + 4*40, 230);
    RVDispDrawAll();
    wait = 30 * RRMainIntervalTime() / 20;
    p1_cont = 0;
    p2_cont = com_level;
    pass_count = 0;
    RVDataSoundRequest("S ON 0 21 255 255");
    RVDataBGMRequest(3);
    RVAnimRequest(0);
    turn_step = T_P1_INIT;
    game_step = G_WAIT;
    break;

  case G_WAIT:
    /* -- äȥ֤Ƥߤ */
    if (((wait--) <= 0) || ((click = RRInputClick()) != NULL)) {
      wait = 20;
      game_step = G_INTRO;
    }
    break;

  case G_INTRO:
    /* -- ܡɤȤ */
    switch(RRMainIntervalTime()) {
    case 5:
      wait -= 2;
    case 10:
      wait--;
    case 20:
      wait--;
    }
    if ((wait <= 0) || ((click = RRInputClick()) != NULL)) {
      wait = 0;
      game_step = G_MAIN;
    }
    /* -- ư */
    RVDispScorePos(484, 12 - 8*wait);
    RVDispCharaPos(488 + 8*wait, 230);
    RVDispDraw();
    break;

  case G_MAIN:
    /* --  */
    {
      RVBoardKomaAnim();
      RVDispDraw();
      game_turn();
      if ((turn_step == T_END) || (pass_count >= 2)) {
	game_step = G_GAME_END;
      }
    }
    break;

  case G_GAME_END:
    localtimer = 0;
    RVDataBGMRequest(0);
    switch(game_winner()) {
    case 0:
      RVAnimRequest(3);
      RVDispInfoDisp(4);
      RVDispLightMode(TRUE);
      game_step = G_P_WIN;
      break;
    case 1:
      RVAnimRequest(2);
      RVDispInfoDisp(3);
      RVDispLightMode(TRUE);
      game_step = G_P_WIN;
      break;
    case 2:
      RVAnimRequest(3);
      RVDispInfoDisp(2);
      RVDispLightMode(TRUE);
      game_step = G_P_LOSE;
      break;
    }
    break;

  case G_P_WIN:
    t = ((localtimer * 20) / RRMainIntervalTime());
    if (t < 20) {
      RVDispInfoPos(320, 240 + (sin(((3.1415/2.0)*(20-t)/20))*260));
    }
    else if (t < 100) {
      RVDispInfoPos(320, 240);
    }
    else if (t < 120) {
      RVDispInfoPos(320, 240 - (sin((3.1415/2.0)*(t-100)/20))*320);
    }
    else {
      game_step = G_END;
    }
    if (t == 20) {
      RVDataSoundRequest("S ON 0 6 255 255");
    }
    RVDispDraw();
    break;

  case G_P_LOSE:
    t = ((localtimer * 20) / RRMainIntervalTime());
    if (t < 20) {
      RVDispInfoPos(320, 240 - (sin(((3.1415/2.0)*(20-t)/20))*260));
    }
    else if (t < 100) {
      RVDispInfoPos(320, 240);
    }
    else if (t < 120) {
      RVDispInfoPos(320, 240 + (sin((3.1415/2.0)*(t-100)/20))*320);
    }
    else {
      game_step = G_END;
    }
    if (t == 20) {
      RVDataSoundRequest("S ON 0 7 255 255");
    }
    RVDispDraw();
    break;

  case G_DRAW:
    game_step = G_END;
    break;

  case G_END:
    switch(game_winner()) {
    case 0:
      game_stat = GAME_DRAW;
      break;
    case 1:
      game_stat = GAME_P_WIN;
      break;
    case 2:
      game_stat = GAME_P_LOSE;
      break;
    }
    break;

  default:

  }

  /* -----------------------------------------------
     饢˥ɥ饤С
   ------------------------------------------------ */
    RVDispCharaSet(RVAnimSequence());
}




/* -------------------------------------------------------------
   -- ʹԤ⤦äȺʬ
-------------------------------------------------------------- */

/* -------------------------------------------------------------
  game_turn      -- μ

   return : void
   void

-------------------------------------------------------------- */
void  game_turn(void)
{
  gint  pos = 0;
  gint  ptimer, t, num, r;

  /* -----------------------------------------------
     󥹥ƥå׽
   ------------------------------------------------ */
  switch(turn_step) {
  case T_P1_INIT:
    RRInputFlashClick();
    if (RVBoardCheckPass(2) == FALSE) {
      com_start(p1_cont);
      turn_step = T_P1_PUT;
    }
    else {
      ttimer = 0;
      turn_step = T_P1_PASS_BEFORE;
    }
    if (game_finish() == TRUE) {
      turn_step = T_END;
    }
    break;

  case T_P1_PUT:
    pos = control_input(p1_cont);
    if (pos != -1) {
      /* -- ֤뤫ɤ */
      if (RVBoardAbleToPut(2, pos) > 0){
	RVBoardPutKoma(2, pos);
	pos_keep = pos;
	turn_step = T_P1_PUTANIM;
      }
    }
    break;

  case T_P1_PUTANIM:
    if (RVBoardKomaAnimStat() == FALSE) {
      /* -- ΤҤä꤫ */
      num = RVBoardReverseKoma(2, pos_keep);
      if (num > 2) {
	if (num > 5) {
	  RVAnimRequest(4);
	  RVDataSoundRequest("S ON 2 26 255 255");
	}
	else {
	  RVAnimRequest(6);
	  r = time(NULL) % 2;
	  if (r == 0) {
	    RVDataSoundRequest("S ON 2 24 255 255");
	  }
	  else {
	    RVDataSoundRequest("S ON 2 25 255 255");
	  }
	}
      }
      turn_step = T_P1_ANIM;
    }
    break;

  case T_P1_ANIM:
    game_score();
    if (RVBoardKomaAnimStat() == FALSE) {
      RVAnimRequest(0);
      pass_count = 0;
      turn_step = T_P2_INIT;
    }
    break;

  case T_P1_PASS_BEFORE:
    ttimer++;
    if (ttimer > 4) {
      ttimer = 0;
      pass_count++;
      RVDispInfoDisp(1);
      RVDispLightMode(TRUE);
      turn_step = T_P1_PASS;
      RVDataSoundRequest("S ON 2 5 255 255");
      RVAnimRequest(5);
    }
    break;

  case T_P1_PASS:
    ptimer = 60 - ((ttimer * 20) / RRMainIntervalTime());
    if (ptimer <= 0) {
      RVAnimRequest(0);
      RVDispInfoDisp(0);
      RVDispLightMode(FALSE);
      RVDispDrawAll();
      turn_step = T_P2_INIT;
      break;
    }
    /* -- ѥʸɽ */
    if (ptimer >= 40) {
      t = ptimer - 40;
      RVDispInfoPos((gint)(cos(2.0*3.1415*(gfloat)t/20)*(700*t/20))+320,
		    (gint)(sin(2.0*3.1415*(gfloat)t/20)*(350*t/20))+240);
    }
    else if (ptimer >= 20) {
      RVDispInfoPos(320, 240);
    }
    else {
      t = 20 - ptimer;
      RVDispInfoPos((gint)(-cos(2.0*3.1415*(gfloat)t/20)*(700*t/20))+320,
		    (gint)(-sin(2.0*3.1415*(gfloat)t/20)*(350*t/20))+240);
    }
    /* --  */
    ttimer++;
    break;

  case T_P2_INIT:
#if 0
    /* --- thinking anime */
    RVAnimRequest(1);
#endif
    RRInputFlashClick();
    if (RVBoardCheckPass(1) == FALSE) {
      com_start(p2_cont);
      turn_step = T_P2_PUT;
    }
    else {
      ttimer = 0;
      turn_step = T_P2_PASS_BEFORE;
    }
    if (game_finish() == TRUE) {
      turn_step = T_END;
    }
    break;

  case T_P2_PUT:
    pos = control_input(p2_cont);
    if (pos != -1) {
#if 0
      /* --- normal face */
      RVAnimRequest(0);
#endif
      /* -- ֤뤫ɤ */
      if (RVBoardAbleToPut(1, pos) > 0){
	RVBoardPutKoma(1, pos);
	pos_keep = pos;
	turn_step = T_P2_PUTANIM;
      }
    }
    break;

  case T_P2_PUTANIM:
    if (RVBoardKomaAnimStat() == FALSE) {
      /* -- ΤҤä꤫ */
      num =RVBoardReverseKoma(1, pos_keep);
      if (num > 2) {
	if (num > 5) {
	  RVAnimRequest(5);
	  RVDataSoundRequest("S ON 2 29 255 255");
	}
	else {
	  RVAnimRequest(7);
	  r = time(NULL) % 2;
	  if (r == 0) {
	    RVDataSoundRequest("S ON 2 27 255 255");
	  }
	  else {
	    RVDataSoundRequest("S ON 2 28 255 255");
	  }
	}
      }
      else {
	r = time(NULL) % 2;
	if (r == 0) {
	  RVDataSoundRequest("S ON 2 22 255 255");
	}
	else {
	  RVDataSoundRequest("S ON 2 23 255 255");
	}
      }
      turn_step = T_P2_ANIM;
    }
    break;

  case T_P2_ANIM:
    game_score();
    if (RVBoardKomaAnimStat() == FALSE) {
      RVAnimRequest(0);
      pass_count = 0;
      turn_step = T_P1_INIT;
    }
    break;

  case T_P2_PASS_BEFORE:
    ttimer++;
    if (ttimer > 4) {
      ttimer = 0;
      pass_count++;
      RVDispInfoDisp(1);
      RVDispLightMode(TRUE);
      RVDataSoundRequest("S ON 2 5 255 255");
      RVAnimRequest(4);
      turn_step = T_P2_PASS;
    }
    break;

  case T_P2_PASS:
    ptimer = 60 - ((ttimer * 20) / RRMainIntervalTime());
    if (ptimer <= 0) {
      RVAnimRequest(0);
      RVDispInfoDisp(0);
      RVDispLightMode(FALSE);
      RVDispDrawAll();
      turn_step = T_P1_INIT;
      break;
    }
    /* -- ѥʸɽ */
    if (ptimer >= 40) {
      t = ptimer - 40;
      RVDispInfoPos((gint)(cos(2.0*3.1415*(gfloat)t/20)*(600*t/20))+320,
		    (gint)(sin(2.0*3.1415*(gfloat)t/20)*(350*t/20))+240);
    }
    else if (ptimer >= 20) {
      RVDispInfoPos(320, 240);
    }
    else {
      t = 20 - ptimer;
      RVDispInfoPos((gint)(-cos(2.0*3.1415*(gfloat)t/20)*(600*t/20))+320,
		    (gint)(-sin(2.0*3.1415*(gfloat)t/20)*(350*t/20))+240);
    }
    /* --  */
    ttimer++;
    break;

  case T_END:
    break;
  }
}


/* -------------------------------------------------------------
  control_input      -- ץ쥤䡼ڤӥԥ塼λ׹

   return : gint pos (֤ -1=no control)
   gint player(0=Player, 1=COM level)

-------------------------------------------------------------- */
gint  control_input(gint player)
{
  RRClick *inp;
  gint  pos;

  pos = -1;
  switch(player) {
  case 0:
    if ((inp = RRInputClick()) != NULL) {
      if ((inp->x > 8) && (inp->x < 472) &&
	  (inp->y > 8) && (inp->y < 472)) {
	pos = ((inp->x - 9) / 58) + (((inp->y - 9) / 58) * 8);
      }
    }
    break;

  default:
    /* --- ԥ塼ǤļϷޤäʡ */
    if (RVComStat() == FALSE) {
      pos = RVComGet();
    }
    break;
  }

  return(pos);
}


/* -------------------------------------------------------------
  com_start      -- ԥ塼λ׹ͥ롼󥹥

   return : void
   gint player(0=Player, 1=COM level)

-------------------------------------------------------------- */
void  com_start(gint level)
{
  if (level == 0) return;

  /* --- ԥ塼λ׹ͥ롼򥹥åɲ
         ͽʤΤǤʼˤʤäƤΤǤ */
  /* -- åɲȤ process fork ˤʤ뤫 */

  RVComStart(level);
}


/* -------------------------------------------------------------
  game_score      -- ߤɽ
-------------------------------------------------------------- */
void  game_score(void)
{
  RVKoma *board;
  gint  p1, p2, i;

  p1 = p2 = 0;
  for(i=0; i<64; i++) {
    board = RVBoardKoma(i);
    switch(board->stat){
    case 1:
      p2++;
      break;
    case 2:
      p1++;
      break;
    }
  }
  RVDispScoreSet(p1, p2);
  if((p1 == 0) || (p2 == 0)) {
    game_step = G_GAME_END;
  }
}

/* -------------------------------------------------------------
  game_winner      -- η̽
-------------------------------------------------------------- */
gint  game_winner(void)
{
  RVKoma *board;
  gint  p1, p2, i, r;

  p1 = p2 = r = 0;
  for(i=0; i<64; i++) {
    board = RVBoardKoma(i);
    switch(board->stat){
    case 1:
      p2++;
      break;
    case 2:
      p1++;
      break;
    }
  }
  if (p1 > p2) r = 1;
  if (p1 < p2) r = 2;
  if (p1 == p2) r = 0;

  return(r);
}


/* -------------------------------------------------------------
  game_finish      -- νλȽ
-------------------------------------------------------------- */
gboolean game_finish(void)
{
  RVKoma *board;
  gint i;
  gboolean  r;

  r = TRUE;
  for(i=0; i<64; i++) {
    board = RVBoardKoma(i);
    if (board->stat == 0){
      r = FALSE;
    }
  }

  return(r);
}
